=== debian/changelog ===
pgn-extract (17.55-1) unstable; urgency=medium

  * New upstream release
    - Update get-orig-source target
    - Refresh makefile.patch
  * Standards-Version 4.1.2
  * pgn-extract is now under GPL-3+

 -- Vincent Legout <vlegout@debian.org>  Sun, 17 Dec 2017 12:46:54 +0100
