=== debian/rules ===
#!/usr/bin/make -f

VERSION=17.55

%:
	dh $@

get-orig-source:
	wget ftp://ftp.cs.kent.ac.uk/pub/djb/pgn-extract/pgn-extract.tgz
	tar zxvf pgn-extract.tgz
	mv pgn-extract pgn-extract-$(VERSION)
	tar czf pgn-extract_$(VERSION).orig.tar.gz pgn-extract-$(VERSION)
	rm -rf pgn-extract-$(VERSION) pgn-extract.tgz
