## pgn-extract 18.10

=== Makefile ===
--- 
+++ 
@@ -1,7 +1,7 @@
 # Make file for the pgn-extract program.
 #
 #  This file is part of pgn-extract: a Portable Game Notation (PGN) extractor.
-#  Copyright (C) 1994-2017 David J. Barnes
+#  Copyright (C) 1994-2018 David J. Barnes
 #
 #  pgn-extract is free software: you can redistribute it and/or modify
 #  it under the terms of the GNU General Public License as published by
@@ -39,7 +39,7 @@
 	-Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings \
 	-Wsign-compare -Wimplicit-function-declaration $(DEBUGINFO) \
 	-I/usr/local/lib/ansi-include -std=c99 \
-	-O3
+        -O3
 	 
 CC=gcc
