=== debian/changelog ===
pgn-extract (18.10-1) unstable; urgency=medium

  * New upstream release
    - Update get-orig-source target
  * patches: rename remove_iframe.patch to privacy.patch, and update to remove
    Google Analytics
  * Set Vcs fields to salsa.debian.org

 -- Vincent Legout <vlegout@debian.org>  Tue, 13 Nov 2018 06:43:01 +0100

pgn-extract (18.08-1) unstable; urgency=medium

  * New upstream release
    - Update get-orig-source target
  * Standards-Version 4.2.1
  * Update to debhelper 11
  * debian/copyright: refresh copyright years, use https urls
  * debian/rules: add hardening flags
  * add debian/patches/remove_iframe.patch to remove iframe with remote mp4
  * install style.css, add it in debian/docs

 -- Vincent Legout <vlegout@debian.org>  Sat, 20 Oct 2018 07:05:42 +0200
