=== debian/control ===
--- 
+++ 
@@ -2,9 +2,11 @@
 Section: games
 Priority: optional
 Maintainer: Vincent Legout <vlegout@debian.org>
-Build-Depends: debhelper (>= 9)
-Standards-Version: 4.1.2
+Build-Depends: debhelper (>= 11~)
+Standards-Version: 4.2.1
 Homepage: http://www.cs.kent.ac.uk/people/staff/djb/pgn-extract/
+Vcs-Browser: https://salsa.debian.org/vlegout/pgn-extract
+Vcs-Git: https://salsa.debian.org/vlegout/pgn-extract.git
 
 Package: pgn-extract
 Architecture: any
