## pgn-extract 19.04

=== Makefile ===
--- 
+++ 
@@ -1,7 +1,7 @@
 # Make file for the pgn-extract program.
 #
 #  This file is part of pgn-extract: a Portable Game Notation (PGN) extractor.
-#  Copyright (C) 1994-2018 David J. Barnes
+#  Copyright (C) 1994-2019 David J. Barnes
 #
 #  pgn-extract is free software: you can redistribute it and/or modify
 #  it under the terms of the GNU General Public License as published by
@@ -35,11 +35,14 @@
 # Mac OS X users might need to add -D__unix__ to CFLAGS
 # and use CC=cc or CC=gcc
 
+OPTIMISE=-O3
+
 CFLAGS+=-c -pedantic -Wall -Wshadow -Wformat -Wpointer-arith \
 	-Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings \
 	-Wsign-compare -Wimplicit-function-declaration $(DEBUGINFO) \
 	-I/usr/local/lib/ansi-include -std=c99 \
-        -O3
+        $(CPPFLAGS) \
+        $(OPTIMISE)
 	 
 CC=gcc
 
@@ -49,7 +52,7 @@
 AIX_CC=xlc
 
 pgn-extract : $(OBJS)
-	$(CC) $(DEBUGINFO) $(OBJS) -o pgn-extract
+	$(CC) $(DEBUGINFO) $(ORIGCFLAGS) $(CPPFLAGS) $(LDFLAGS) $(OBJS) -o pgn-extract
 
 purify : $(OBJS)
 	purify $(CC) $(DEBUGINFO) $(OBJS) -o pgn-extract
