=== test/Makefile ===
--- 
+++ 
@@ -1,5 +1,5 @@
 # Makefile to run a battery of tests of the basic functionality of pgn-extract.
-# Copyright (C) David J. Barnes, 2013-2018
+# Copyright (C) David J. Barnes, 2013-2019
 #
 # Each test is run and then, where relevant, a comparison is made between
 # the output files generated in the current directory and the 'oracle'
@@ -45,7 +45,7 @@
      test-selectonly test-fifty test-repetition test-promotion \
      test-fixresulttags test-fuzzydepth test-setup test-stopafter \
      test-skipmatching test-splitvariants test-nobadresults test-allownullmoves \
-     test-matchplylimit test-nestedcomments test-FENPattern
+     test-matchplylimit test-nestedcomments test-FENPattern test-dropply
 
 # BEWARE: This removes all PGN files in the current directory.
 # The required test PGN files are assumed to be in $(INPUT).
