=== debian/changelog ===
pgn-extract (19.04-1) unstable; urgency=medium

  * New upstream release
    - manpage now upstream, remove it from debian/
  * Update patches:
    - remove debian/patches/makefile.patch, applied upstream
    - refresh debian/patches/privacy.patch, partially applied upstream
  * Standards-Version 4.3.0
  * Add debian/gitlab-ci.yml

 -- Vincent Legout <vlegout@debian.org>  Tue, 07 May 2019 07:45:10 +0200
