=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Vincent Legout <vlegout@debian.org>
 Build-Depends: debhelper (>= 11~)
-Standards-Version: 4.2.1
+Standards-Version: 4.3.0
 Homepage: http://www.cs.kent.ac.uk/people/staff/djb/pgn-extract/
 Vcs-Browser: https://salsa.debian.org/vlegout/pgn-extract
 Vcs-Git: https://salsa.debian.org/vlegout/pgn-extract.git
